[org 100h]
[segment .text]
	mov  cx, cs		; alokace pameti
	mov  es, cx
	mov  ah, 4Ah
	mov  bx, 4000		; 64000 / 16 = 4000 paragrafu
	int  21h
	jc   outuj		; skonci

aok:	add  cx, 4096
	mov  [scr],cx		; scr - muj virtual screen

	call MAPbuild		; vytvor mapu lupy

	mov  si, 93		; nacteme command line
	mov  di, file
	mov  cx, 8		; maximalni delka jmena souboru je 8 znaku

soub:	lodsb
	cmp  al, ' '
	jz   lok		; cele jmeno?
	stosb
	loop soub
lok:	mov  eax, '.tga'	; + pripona
	stosd

	mov  ah, 3dh		; open file
	mov  dx, file
	int  21h
	jnc  fok		; podarilo se otevrit?
outuj:	ret

fok:	mov  bx, ax		; do BX handle souboru

	mov  ah, 0Fh
	int  10h
	cbw
	push ax			; uloz rezim
	mov  al, 13h
	int  10h		; nastav graficky rezim
       
	mov  ax, 4200h		; lseek file
	xor  cx, cx		; CX: DX - offset
	mov  dx, 18		; paleta zacina na offsetu 18
	int  21h

	push ds
	mov  ax, [scr]		; ulozime do virtual screenu (pak to stejne prepisem)
	mov  ds, ax
	mov  es, ax

	xor  dx, dx		; DS:DX - adresa, kam ulozit
	mov  ah, 3fh		; read file
	mov  cx, 768
	int  21h

	mov  dx, 03c8h
        mov  al, 0
	out  dx, al		; priprav vystup palety
	inc  dx

	xor  si, si
	mov  cx, 256		; 256 barev

pal:	lodsb			; je to chytre zprehazeny
	push ax
	lodsw
	xchg al, ah
	shr  ax, 2
	out  dx, al
	xchg al, ah
	out  dx, al
	pop  ax
	shr  al, 2
	out  dx, al
	loop pal

	xor  dx, dx		; DS: DX - kam
	mov  ah, 3fh		; read file
	mov  cx, 64000
	int  21h

	mov  ah, 3eh		; close file
	int  21h
	pop  ds

	xor  ax, ax
	int  33h
	test ax, ax		; pritomna mys?
	jz   outuj

mok:	mov  ax, 7
	xor  cx, cx		; min X,Y
	mov  dx, 321-2*R	; max X
	int  33h
	inc  ax
	mov  dx, 201-2*R	; max Y
	int  33h
	
; -------------------
; Vlastni kresleni
; -------------------

start:	mov  ax, 3h		; nacteme polohu mysi
	int  33h
	mov  ax, 320
	mul  dx
	add  ax, cx		; ax = 320*y + x
	push ax			; pro obnovu

; --- ulozeni casti virtual screen do vyrezu
	mov  si, ax		; si = 320*y + x

	push ds
	push ds
	pop  es			; ES - offset kam zapisujem
	push word [scr]
	pop  ds			; DS - offset co zapisujem
	mov  di, vyrez		; sem to zapisem

	mov  bx, 2*R-1		; velikost mapy y
udalsi:	mov  cx, 2*R-1		; velikost mapy x
	rep movsb		; prepis radek
	add  si, 321-2*R
	dec  bx
	jnz  udalsi		; dalsi radek

	pop  ds

; --- vylupime
	mov  di, ax		; di = 320*y + x

	push word [scr]
	pop  es			; sem zapisuju
	mov  si, map		; odtud ctu
	mov  bp, vyrez

	mov  bx, 2*R-1
ly:	mov  cx, 2*R-1
lx:	lodsw			; nacteme z mapy offset
	add  bp, ax		; pripocteme ho - kam se ma posunou
	mov  al, [ds:bp]	; zjistime ten pixel
	stosb			; a zapiseme ho

	loop lx
	add  di, 321-2*R	; a udelam to pro dalsi radku
	dec  bx
	jnz  ly

; --- virtual screen do video ram
	push ds
      	push word 0A000h
	pop  es			; ES - videoram
	mov  ds, [scr]		; DS - virtual screen
	xor  di, di
	xor  si, si
	mov  cx, 64000
	rep movsb		; prepis
	pop  ds

testuj:	mov  ax, 0bh		; nacteme relativni zmenu mysi
	int  33h
	add  cx, dx
	jnz  pohyb		; pohnul uzivatel mysi?

	mov  ah, 6
	mov  dl, 0ffh
	int  21h
	jz   testuj		; stisk klavesy?

konec:	pop  ax			; to nam tam zbylo

	pop  ax			; obnov stary rezim
	int  10h
end:	ret			; KONEC PROGRAMU

pohyb:	pop  di			; di = 320*y + x

; --- obnov stary vyrez
	push word [scr]
	pop  es			; sem zapisujem
	mov  si,vyrez		; tohle zapisujem

	mov  bx, 2*R-1
odalsi:	mov  cx, 2*R-1
	rep movsb
	add  di, 321-2*R
	dec  bx
	jnz  odalsi

	jmp  start		; prekreslime lupu

; -------------------------------------------------------

MAPbuild:mov      AX, DS		; MAPBuild z netu
	mov       ES, AX
	mov       BX, 1-R
	mov       SI, R*R
	mov       DI, map
	mov       BP, -2*R*(R-1)

nok	mov       CX, 1-R
nol	mov       AX, CX
	imul      CX
	push      AX
	mov       AX, BX
	imul      BX
	pop       DX
	add       AX, DX
	cmp       AX, SI
	jc        nor
	mov       AX, BX
	push      CX
	jmp       short nos
nor	mov       DX, 65536*(M-N)/M/N
	mul       DX
	mov       AX, DX
	add       AX, R*R/M
	push      AX
	imul      CX
	idiv      SI
	mov       DX, AX
	pop       AX
	push      DX
	imul      BX
	idiv      SI
nos	mov       AH, 2*R-1
	imul      AH
	pop       DX
	add       AX, DX
	push      AX
	sub       AX, BP
	stosw
	pop       BP
	inc       CX
	cmp       CL, R
	jl        nol
	inc       BX
	cmp       BL, R
	jl        nok
	ret

R	equ	31			; parametry mapy
N	equ	2
M	equ	3

file	resb	8			; jmeno souboru
vyrez	resb	(2*R-1)*(2*R-1)		; ulozeni vyrezu pred zvetsenim
map	resw	(2*R-1)*(2*R-1)		; vlastni mapa, ze ktere pocitame zvetseni
scr	dw	0			; zacatek virtual screenu